/**
 * Copyright (c) 2007, Jeong Ho Wook.
 * E-mail : sophistlv@yahoo.co.kr
 * All free. ^^*
 * Version 0.0.1
 */

/**
 * web.util.debug class
 * client debug window manager class
 */
web.util.debug = {

/**
 * debug window ü
 */
    oDebug:null,

/**
 * debug window id/name
 */
    sDebugId:"",

/**
 * debug window ݱ status
 */
    bDebugClose:false,

/**
 * client browser  
 */
    nClientHeight:0,

/**
 * client browser  
 */
    nClientWidth:0,

/**
 * debug window 
 */
    nDebugHeight:300,

/**
 * debug window 
 */
    nDebugWidth:350,

/**
 * debug window  background 
 */
    sBgColor:"#00FF00",

/**
 * debug window  µǴ  ũ
 */
    sFontSize:"12px",

/**
 * logging  ð  
 */
    bTime:true,

/**
 * debug window  toolbar layer ü
 */
    oToolbar:null,

/**
 * toolbar ü id/name
 */
    sToolbarId:"",

/**
 * toolbar 
 */
    nToolbarHeight:80,

/**
 * toolbar 
 */
    nToolbarWidth:350,

/**
 * debug â  ʱȭ
 *
 * @param sID ϰ ϴ ü id/name
 */
    init:function ( sID ) {
        var sElType="";
        var aElValue = new Array();
        var oElement = web.util.element;

        this.set_debug_id( sID );
        this.set_client_size();

        sElType = "body";
        aElValue["type"] = "div";
        aElValue["id"] = sID;
        aElValue["name"] = sID;
        aElValue["style"] = new Array();

        if ( web.util.get_browser() == "Microsoft" ) {
            aElValue["style"]["list"] = "padding,border,backgroundColor,fontSize,scrollbarBaseColor,wordWrap,overflow,overflowX,width,height,position,top,left,zIndex";
            aElValue["style"]["backgroundColor"] = this.sBgColor;
            aElValue["style"]["scrollbarBaseColor"] = "#FFFFFF";
            aElValue["style"]["overflowX"] = "hidden";
            aElValue["style"]["fontSize"] = this.sFontSize;
            aElValue["style"]["wordWrap"] = "break-word";
            aElValue["style"]["padding"] = "10px 10px";
        } else {
            aElValue["style"]["list"] = "border,background-color,font-size,scrollbar-base-color,overflow,overflow-x,width,height,position,top,left,zIndex";
            aElValue["style"]["background-color"] = this.sBgColor;
            aElValue["style"]["scrollbar-base-color"] = "#FFFFFF";
            aElValue["style"]["overflow-x"] = "hidden";
            aElValue["style"]["font-size"] = this.sFontSize;
        }

        aElValue["style"]["border"] = "thin solid black";
        aElValue["style"]["overflow"] = "auto";
        aElValue["style"]["position"] = "absolute";
        aElValue["style"]["height"] = this.nDebugHeight;
        aElValue["style"]["width"] = this.nDebugWidth;
        aElValue["style"]["top"] = 0;
        aElValue["style"]["left"] = 0;
        aElValue["style"]["zIndex"] = "100";

        oElement.set_remove_element(sElType, oElement.oLayerDiv);
        oElement.oLayerDiv = null;

        if ( oElement.bLayerDiv ) {
            oElement.bLayerDiv = false;
        } else {
            oElement.bLayerDiv = true;
            oElement.oLayerDiv = oElement.set_create_element(sElType, aElValue);
            this.oDebug = document.all[sID];
            this.oDebug.style.top = this.get_debug_y();
            this.oDebug.style.left = this.get_debug_x();
            window.onresize = this.set_client_resize;
        }

        this.set_toolbar("oWebDebugToolbar");
    },

/**
 * toolbar 
 *
 * @param sID ϰ ϴ toolbar  id/name
 */
    set_toolbar:function ( sID ) {
        var sElType="";
        var aElValue = new Array();
        var oElement = web.util.element;

        this.set_toolbar_id( sID );

        sElType = "body";
        aElValue["type"] = "div";
        aElValue["id"] = sID;
        aElValue["name"] = sID;
        aElValue["style"] = new Array();

        if ( web.util.get_browser() == "Microsoft" ) {
            aElValue["style"]["list"] = "padding,border,backgroundColor,fontSize,width,height,position,top,left,zIndex";
            aElValue["style"]["backgroundColor"] = "#C0C0C0";
            aElValue["style"]["fontSize"] = this.sFontSize;
            aElValue["style"]["padding"] = "10px 10px";
        } else {
            aElValue["style"]["list"] = "border,background-color,font-size,width,height,position,top,left,zIndex";
            aElValue["style"]["background-color"] = "#C0C0C0";
            aElValue["style"]["font-size"] = this.sFontSize;
        }

        aElValue["style"]["border"] = "thin solid black";
        aElValue["style"]["position"] = "absolute";
        aElValue["style"]["height"] = this.nToolbarHeight;
        aElValue["style"]["width"] = this.nToolbarWidth;
        aElValue["style"]["top"] = 0;
        aElValue["style"]["left"] = 0;
        aElValue["style"]["zIndex"] = "100";

        oElement.set_remove_element(sElType, this.oToolbar);
        this.oToolbar = null;

        if ( oElement.bLayerDiv ) {
            oElement.set_create_element(sElType, aElValue);
            this.oToolbar = document.all[sID];
            this.oToolbar.style.top = this.get_toolbar_y();
            this.oToolbar.style.left = this.get_toolbar_x();
            this.oToolbar.innerHTML = 
            "<input style=\"font-size:10px\" type=button value=\"WINDOW ON/OFF\" onclick=\"web.util.debug.init('oWebDebug')\"><br>"+
            "<input style=\"font-size:10px\" type=button value=\"CLEAN\" onclick=\"web.util.debug.set_clean()\"> | <input style=\"font-size:10px\" type=button value=\"OPEN/CLOSE\" onclick=\"web.util.debug.set_close()\"><br>"+
            "<input style=\"font-size:10px\" type=button value=\"TIME ON/OFF\" onclick=\"web.util.debug.set_time_switch()\">";
        }
    },

/**
 * log 
 *
 * @param sM ϰ ϴ ޽
 */
    log:function ( sM ) {
        if ( this.bTime ) {
            this.oDebug.innerHTML += "[" + web.util.get_time("ymdhis") + "]<br>" + sM + "<br>";
        } else {
            this.oDebug.innerHTML += sM + "<br>";
        }
    },

/**
 *  â ޽ ½ ½ð  
 * toggle 
 *
 * @param bOn true : , false : 
 */
    set_time_switch:function ( bOn ) {
        if ( typeof bOn != "undefined" && bOn != null ) {
            this.bTime = bOn;
        } else {
            if ( this.bTime ) {
                this.bTime = false;
            } else {
                this.bTime = true;
            }
        }
    },

/**
 * debug id 
 */
    set_debug_id:function ( sID ) {
        this.sDebugId = sID;
    },

/**
 * toolbar id 
 */
    set_toolbar_id:function ( sID ) {
        this.sToolbarId = sID;
    },

/**
 * debug message 
 */
    set_clean:function () {
        this.oDebug.innerHTML = "debug clean done!!<br>";
    },

/**
 * debug â y 
 */
    get_debug_y:function () {
        if ( web.util.get_browser() == "Microsoft" ) {
            nY = this.nClientHeight - this.nDebugHeight;
        } else {
            nY = this.nClientHeight - this.nDebugHeight - 2;
        }

        return nY;
    },

/**
 * debug â x 
 */
    get_debug_x:function () {
        if ( web.util.get_browser() == "Microsoft" ) {
            nX = this.nClientWidth - this.nDebugWidth;
        } else {
            nX = this.nClientWidth - this.nDebugWidth - 20;
        }

        return nX;
    },

/**
 * toolbar â y 
 */
    get_toolbar_y:function () {
        if ( web.util.get_browser() == "Microsoft" ) {
            nY = this.nClientHeight - this.nDebugHeight - this.nToolbarHeight
        } else {
            nY = this.nClientHeight - this.nDebugHeight - this.nToolbarHeight - 2;
        }

        return nY;
    },

/**
 * toolbar â x 
 */
    get_toolbar_x:function () {
        if ( web.util.get_browser() == "Microsoft" ) {
            nX = this.nClientWidth - this.nToolbarWidth;
        } else {
            nX = this.nClientWidth - this.nToolbarWidth - 20;
        }

        return nX;
    },

/**
 * client browser â ũ 
 */
    set_client_size:function () {
        if ( web.util.get_browser() == "Microsoft" ) {
            this.nClientHeight = document.body.clientHeight;
            this.nClientWidth = document.body.clientWidth;
        } else {
            this.nClientHeight = window.innerHeight;
            this.nClientWidth = window.innerWidth;
        }
    },

/**
 * browser ũ  ġ  
 */
    set_client_resize:function () {
        var oThis = web.util.debug;
        oThis.set_client_size();
        oThis.oDebug.style["top"] = oThis.get_debug_y();
        oThis.oDebug.style["left"] = oThis.get_debug_x();
        oThis.oToolbar.style["top"] = oThis.get_toolbar_y();
        oThis.oToolbar.style["left"] = oThis.get_toolbar_x();
    },

/**
 * debug window  toggle 
 */
    set_close:function () {
        if ( this.bDebugClose ) {
            this.bDebugClose = false;
            this.oDebug.style["visibility"] = "visible";
        } else {
            this.bDebugClose = true;
            this.oDebug.style["visibility"] = "hidden";
        }
    }
}

web.namespace("web.util.debug");
