/**
 * Copyright (c) 2007, Jeong Ho Wook.
 * E-mail : sophistlv@yahoo.co.kr
 * All free. ^^*
 * Version 0.0.1
 */

/**
 * web.util class
 * basic utility
 */
web.util = {

/**
 * client  ϰ ִ   
 *
 * @return string browser name
 */
    get_browser:function () {
        var bIE = (navigator.appName.indexOf("Microsoft") != -1);
        var bNav = (navigator.appName.indexOf("Netscape") != -1);
    
        if ( bIE ) {
            return "Microsoft";
        }
    
        if ( bNav ) {
            return "Netscape";
        }
    },

/**
 * Data ü ̿ؼ ¥, ð ϱ
 *
 * @param sType
 *      y : 
 *      m : 
 *      d : 
 *      h : 
 *      i : 
 *      s : 
 *      ms : и
 *      e.g) ymdhis
 * @return string "2007/4/4 13:5:4"
 */
    get_time:function ( sType ) {
        var oDate = new Date();
        var sTimestamp;

        switch(sType){
            case "ymdhis" :
                sTimestamp = oDate.getFullYear()+"/"+(oDate.getMonth()+1)+"/"+oDate.getDate()+" "+oDate.getHours()+":"+oDate.getMinutes()+":"+oDate.getSeconds();
                break;
            case "mdhis" :
                sTimestamp = (oDate.getMonth()+1)+"/"+oDate.getDate()+" "+oDate.getHours()+":"+oDate.getMinutes()+":"+oDate.getSeconds();
                break;
            case "dhis" :
                sTimestamp = oDate.getDate()+" "+oDate.getHours()+":"+oDate.getMinutes()+":"+oDate.getSeconds();
                break;
            case "his" :
                sTimestamp = oDate.getHours()+":"+oDate.getMinutes()+":"+oDate.getSeconds();
                break;
            case "ymd" :
                sTimestamp = oDate.getFullYear()+"/"+(oDate.getMonth()+1)+"/"+oDate.getDate();
                break;
            case "ymdh" :
                sTimestamp = oDate.getFullYear()+"/"+(oDate.getMonth()+1)+"/"+oDate.getDate()+" "+oDate.getHours();
                break;
            case "ymdhi" :
                sTimestamp = oDate.getFullYear()+"/"+(oDate.getMonth()+1)+"/"+oDate.getDate()+" "+oDate.getHours()+":"+oDate.getMinutes();
                break;
            case "y" :
                sTimestamp = oDate.getFullYear();
                break;
            case "m" :
                sTimestamp = (oDate.getMonth()+1);
                break;
            case "d" :
                sTimestamp = oDate.getDate();
                break;
            case "h" :
                sTimestamp = oDate.getHours();
                break;
            case "i" :
                sTimestamp = oDate.getMinutes();
                break;
            case "s" :
                sTimestamp = oDate.getSeconds();
                break;
            case "ms" :
                sTimestamp = oDate.getMilliseconds();
                break;
        }
    
        return sTimestamp;
    }
}

web.namespace("web.util");
